Summary: Consistent/persistent storage device access through symlinking
Name: devlabel
Version: 0.48.01
Release: 1
Copyright: GPL
Group: System Environment/Base
Source: devlabel-%version.tar.gz
Requires: sed grep gawk textutils fileutils diffutils coreutils mktemp
Requires: initscripts > 6.97-1
Requires: util-linux 
BuildPrereq: e2fsprogs-devel
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root/

%description
This package contains the devlabel implementation.  It allows for consistent
mounting of devices.  This is accomplished through tagging a unique identifier 
to each device/symlink combination and confirming that the identifier still
matches the device name before it allows the symlink mapping to proceed.

%prep

%setup -q

%build
gcc $RPM_OPT_FLAGS -o scsi_unique_id scsi_unique_id.c
gcc $RPM_OPT_FLAGS -o partition_uuid -luuid partition_uuid.c

%pre
[ -d /var/lib/devlabel ] && rm -rf /var/lib/devlabel >/dev/null 2>&1
if [ -e /etc/sysconfig/devlabel ]; then
	devlabel_version=`devlabel -v 2>/dev/null`
	old_format=""
	version_major=`echo $devlabel_version | awk {'print $2'} | cut -d '.' -f 1-1`
	version_minor=`echo $devlabel_version | awk {'print $2'} | cut -d '.' -f 2-2`
	[ -z "$version_minor" ] && old_format="true"
	[ -z "$old_format" ] && [ "$version_major" -eq 0 ] && [ "$version_minor" -lt 37 ] && old_format="true"	
        if [ -n "$old_format" ]; then                                                                           
                /sbin/devlabel restart >/dev/null 2>&1 || :
        fi
fi

%triggerpostun -- devlabel <= 0.38.07-1
if [ -e /etc/sysconfig/devlabel ]; then
	/sbin/devlabel reverseremap --force >/dev/null 2>&1 || :	
fi

%install
if [ "$RPM_BUILD_ROOT" != "/" ]; then
	rm -rf $RPM_BUILD_ROOT
fi
mkdir -p $RPM_BUILD_ROOT/{sbin,usr/bin,usr/share/man/man8,etc/sysconfig,etc/sysconfig/devlabel.d}
install -m 755 devlabel $RPM_BUILD_ROOT/sbin/devlabel
install -m 755 scsi_unique_id $RPM_BUILD_ROOT/usr/bin
install -m 755 partition_uuid $RPM_BUILD_ROOT/usr/bin
install -m 644 devlabel.8.gz $RPM_BUILD_ROOT/usr/share/man/man8
install -m 644 sysconfig.devlabel $RPM_BUILD_ROOT/etc/sysconfig/devlabel
install -m 644 ignore_list $RPM_BUILD_ROOT/etc/sysconfig/devlabel.d
install -m 644 ignore_list $RPM_BUILD_ROOT/etc/sysconfig/devlabel.d/proc_partitions

%clean
if [ "$RPM_BUILD_ROOT" != "/" ]; then
	rm -rf $RPM_BUILD_ROOT
fi

%files
%defattr(-,root,root)
/sbin/devlabel
/usr/bin/scsi_unique_id
/usr/bin/partition_uuid
/etc/sysconfig/devlabel.d
%config(noreplace) /etc/sysconfig/devlabel
%{_mandir}/man8/devlabel.8*
%doc AUTHORS COPYING *.patch

%changelog
* Tue Apr 20 2004 Gary Lerhaupt <gary_lerhaupt@dell.com> 0.48.01-1
- Updated man page

* Tue Apr 13 2004 Gary Lerhaupt <gary_lerhaupt@dell.com> 0.47.02-1
- Fixed uuid discovery for JFS partitions.  Problem reported and root-caused by Brad Viviano <viviano@geomagic.com>
- Hack for workaround contributed by Dave Kleikamp <shaggy@austin.ibm.com>
- JFS1 partitions no longer should return filesystem UUIDs, JFS2 should
- Added a fix for partitions with no filesystem UUID which are the 10th or higher partition on a disk

* Fri Mar 26 2004 Gary Lerhaupt <gary_lerhaupt@dell.com> 0.46.01-1
- Added partition_uuid support for reiserfs (thanks to the patch submitted by Roland Friedwagner <r.friedwagner@gmx.net>)
- Thanks Roland!

* Fri Feb 20 2004 Gary Lerhaupt <gary_lerhaupt@dell.com> 0.45.08-1
- Finished clean-up of hard-coded pathnames
- Updated project homepage in the manual

* Wed Feb 18 2004 Gary Lerhaupt <gary_lerhaupt@dell.com> 0.45.06-1
- Clean up temp files after you've made them

* Tue Jan 27 2004 Gary Lerhaupt <gary_lerhaupt@dell.com> 0.45.05-1
- Cleaned up initial script code, removed inconsistencies of hard-coded pathnames

* Thu Jan 15 2004 Gary Lerhaupt <gary_lerhaupt@dell.com> 0.45.04-1
- Fixed an error message which was getting sent to >&22 instead of >&2.
- IDs now have nasty characters taken out of them: [ , \ , / , $ , ^ , * , = and replaced with a _

* Tue Jan 06 2004 Gary Lerhaupt <gary_lerhaupt@dell.com> 0.45.01-1
- Added a check in scsi_unique_id to see if page80/83 are supported before trying to get them
- Thanks to Dan Clark <dclark@aracnet.com> for submitting do_scsi_vpdp_inquiry code

* Thu Dec 11 2003 Gary Lerhaupt <gary_lerhaupt@dell.com> 0.44.01-1
- Moved /var/lib/devlabel to /etc/sysconfig/devlabel.d as the directory must be on the root partition
- Tweaked startup code so it doesnt try to get the ID of commented out lines

* Mon Dec 08 2003 Gary Lerhaupt <gary_lerhaupt@dell.com> 0.43.18-1
- Moved path declaration before check for root so id program works on boot.

* Wed Oct 08 2003 Gary Lerhaupt <gary_lerhaupt@dell.com> 0.43.16-1
- Continued to refine the ignore_list concept
- Removed the ugly first-ping hack

* Tue Oct 07 2003 Gary Lerhaupt <gary_leraupt@dell.com> 0.43.11-1
- Created ignore_list to help avoid annoying read capacity error messages
- Clear the ignore_list if /proc/partitions has changed since the last run of devlabel
- Fine-tuned sfdisk usage
- Added mktemp as a required packaged
- Put a warning in /var/log if device put on ignore_list

* Mon Sep 15 2003 Gary Lerhaupt <gary_lerhaupt@dell.com> 0.42.05-1
- Added sfdisk checking hack to avoid IO errors on bad usb device partition tables

* Thu Jun 26 2003 Gary Lerhaupt <gary_lerhaupt@dell.com> 0.41.02-1
- Changed spec upgrade process to use a trigger instead

* Wed Jun 18 2003 Gary Lerhaupt <gary_lerhaupt@dell.com> 0.41.01-1
- Changed scsi_unique_id to check association values on page83 identifiers (if non-zero, don't use them)
- Fixed devlabel to handle multiple identifiers of the same page and type (concatenates them to form one ID)

* Fri Jun 13 2003 Gary Lerhaupt <gary_lerhaupt@dell.com> 0.40.03-1
- Changed reverseremap so that it comments out lines it doesnt know what to do with
- Added auto-run of reverseremap if old devlabel version detected

* Thu Jun 12 2003 Gary Lerhaupt <gary_lerhaupt@dell.com> 0.38.10-1
- Man page now delivered gzipped always

* Tue Jun 03 2003 Gary Lerhaupt <gary_lerhaupt@dell.com> 0.38.09-1
- Changed Requires for e2fsprogs-devel to BuildPrereq

* Fri May 29 2003 Gary Lerhaupt <gary_lerhaupt@dell.com> 0.38.07-1
- Implemented a native readlink command to make sure it exists
- Added ugly hack to ping a device during a hotplug event so devlabel can then later see it

* Wed May 28 2003 Gary Lerhaupt <gary_lerhaupt@dell.com> 0.38.05-1
- Added reverseremap functionality, suggested by Robert Hentosh <robert_hentosh@dell.com>
- Updated the man page

* Wed May 07 2003 Gary Lerhaupt <gary_lerhaupt@dell.com> 0.37.03-1
- Added quotes to grepping of /proc/partitions

* Mon May 05 2003 Gary Lerhaupt <gary_lerhaupt@dell.com> 0.37.02-1
- Added automatic unmounting of devices which no longer exist, thanks to Steve Venema <s.c.v@attbi.com>

* Thu Apr 24 2003 James A. Pattie <james@pcexperience.com> 0.36.06-2
- Cleaned up RPM spec to use the tarball

* Wed Apr 23 2003 Gary Lerhaupt <gary_lerhaupt@dell.com> 0.36.06-1
- Added sector size to UUID of things without partition UUIDs, thanks to David Balazic <david.balazic@uni-mb.si>
- Cleaned up code since now all UUIDs are unique
- Got rid of --partnum option since it isn't needed anymore
- Updated man page

* Mon Apr 21 2003 Gary Lerhaupt <gary_lerhaupt@dell.com> 0.35.21-1
- Continued adding multipath support
- Grep /etc/fstab on word boundary (/b), reported by Todd Martin <todd.martin@acm.org>
- Replaced other word boundary greps with /b
- Added coreutils RPM requirement because of readlink
- Updated man page

* Wed Apr 16 2003 Gary Lerhaupt <gary_lerhaupt@dell.com> 0.35.16-1
- Continued adding multipath support
- Got rid of all grep -m and replaced it with head -1
- Rawdevice status confirms major/minor numbers

* Tue Apr 15 2003 Gary Lerhaupt <gary_lerhaupt@dell.com> 0.35.04-1
- Began adding multipath support
- Created make_link function to remove duplicate code
- Successful rawmapping output is no longer reported
- Fixed a bug in status when partitions are just deleted

* Tue Apr 15 2003 Gary Lerhaupt <gary_lerhaupt@dell.com> 0.30.15-1
- Update option parsing code
- Change the output format of symlinks when status is displayed
- Don't check disks for partition uuids

* Mon Apr 14 2003 Gary Lerhaupt <gary_lerhaupt@dell.com> 0.30.08-1
- Began adding symlink user,group permissioning
- Removed --uuid cli option so as not to confuse it with new --uid option
- Updated the man page

* Wed Apr 02 2003 Gary Lerhaupt <gary_lerhaupt@dell.com> 0.29.15-1
- Removed sourcing in of redhat function library that was not needed
- Added webpage to man page

* Wed Mar 26 2003 Gary Lerhaupt <gary_lerhaupt@dell.com> 0.29.11-1
- Fixed bug in install script, also putting pointer to where uuid.h can be found

* Wed Feb 05 2003 Gary Lerhaupt <gary_lerhaupt@dell.com> 0.29.10-1
- Fixed spec to handle build environment better

* Mon Jan 20 2003 Gary Lerhaupt <gary_lerhaupt@dell.com> 0.29.08-1
- Various Bugfixes

* Sun Jan 19 2003 Gary Lerhaupt <gary_lerhaupt@dell.com> 0.29.02-1
- Cleaned up the get_id code
- Add requirement for e2fsprogs-devel (need uuid/uuid.h for partition_uuid)

* Fri Jan 17 2003 Gary Lerhaupt <gary_lerhaupt@dell.com> 0.28.02-1
- Completed integration of partition specific identifiers
- Added -v version

* Thu Jan 16 2003 Gary Lerhaupt <gary_lerhaupt@dell.com>
- Added partition_uuid
- Mapping of device UUIDs is now partition specific (instead of just disk specific)

* Mon Jan 13 2003 Gary Lerhaupt <gary_lerhaupt@dell.com>
- Automount must now be specified as an option to avoid automounting the wrong things
- Updated the man page to include --automount option

* Fri Jan 10 2003 Gary Lerhaupt <gary_lerhaupt@dell.com> 0.26.03-1
- Fixed automount so that it checks if device is already mounted first

* Wed Jan 08 2003 Gary Lerhaupt <gary_lerhaupt@dell.com> 0.26.02-1
- Added automount support if entries in /etc/fstab are found

* Thu Dec 19 2002 Gary Lerhaupt <gary_lerhaupt@dell.com> 0.25.05-1
- Added printid function
- devlabel add makes sure symlink is an absolute path
- Added devlabel add by UUID (and partnum)
- Added GPL notification
- Updated man page

* Wed Dec 18 2002 Gary Lerhaupt <gary_lerhaupt@dell.com> 
- Enhanced handling of command line interface

* Mon Dec  2 2002 Bill Nottingham <notting@redhat.com> 0.23-2
- package upstream version
- clean up spec file a little

* Tue Oct 29 2002 Gary Lerhaupt <gary_lerhaupt@dell.com>
- Created scsi_unique_id variable to increase speed
- Fixed unbound raw device status
- Made restart,reload truly synonymous with start

* Mon Oct 28 2002 Gary Lerhaupt <gary_lerhaupt@dell.com>
- Fixed remapping bug

* Mon Oct 21 2002 Gary Lerhaupt <gary_lerhaupt@dell.com>
- Updated man page to reflect interdisk renaming limitation

* Wed Oct 16 2002 Gary Lerhaupt <gary_lerhaupt@dell.com>
- Changed output of raw status

* Thu Oct 10 2002 Gary Lerhaupt <gary_lerhaupt@dell.com> 
- fixed fdisk -l bug

* Mon Oct 7 2002 Gary Lerhaupt <gary_lerhaupt@dell.com>
- changed check to see if device even exists in devlabel add
- changed some seds to awks
- changed reading in of /proc/partitions

* Tue Sep 17 2002 Gary Lerhaupt <gary_lerhaupt@dell.com>
- Got rid of egrep -o usage

* Wed Aug 28 2002 Gary Lerhaupt <gary_lerhaupt@dell.com>
- Transistition devlabel from sysV to /sbin script
- Added rc.sysinit patch

* Tue Aug 27 2002 Gary Lerhaupt <gary_lerhaupt@dell.com>
- Added second hotplug_usb patch for 7.3 and up

* Fri Aug 23 2002 Gary Lerhaupt <gary_lerhaupt@dell.com>
- Add model names to SCSI UUIDs

* Thu Aug 22 2002 Gary Lerhaupt <gary_lerhaupt@dell.com>
- Added log statement for when devlabel is started/restarted
- Added hotplugging patches for pci, usb & ieee1394

* Wed Aug 21 2002 Gary Lerhaupt <gary_lerhaupt@dell.com>
- Added model to IDE UUIDs
- Fixed error messages
- PCMCIA storage works

* Tue Aug 20 2002 Gary Lerhaupt <gary_lerhaupt@dell.com>
- First working release
- Questionable multipath support
- Questionable USB support
- Questionable PCMCIA support
- No hotplug support

* Fri Aug 16 2002 Gary Lerhaupt <gary_lerhaupt@dell.com>
- Initial transition from saferawdevices to devlabel
